<template>
  <b-navbar
    class="nav-pills"
    toggleable="lg"
    type="dark"
    variant="dark"
  >
    <b-navbar-toggle target="nav-collapse" />
    <b-collapse
      id="nav-collapse"
      is-nav
    >
      <b-navbar-nav>
        <b-nav-item
          active-class="active"
          to="/loci"
        >
          Explore
        </b-nav-item>
      </b-navbar-nav>
      <b-navbar-nav>
        <b-nav-item
          :to="{ name: 'favoriteLoci' }"
          active-class="active"
        >
          Favorites
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/filters"
        >
          Filters
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/tags"
        >
          Tags
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/watch-lists"
        >
          Watch Lists
        </b-nav-item>
      </b-navbar-nav>
      <b-navbar-nav>
        <b-nav-item
          active-class="active"
          to="/catalogs"
        >
          Catalogs
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/pipeline"
        >
          Pipeline
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/properties"
        >
          Properties
        </b-nav-item>
      </b-navbar-nav>
      <b-navbar-nav>
        <b-nav-item-dropdown
          v-if="user && user.admin"
          right
          text="Admin Tools"
        >
          <b-dropdown-item to="/admin/filters">
            Filters Management
          </b-dropdown-item>
          <b-dropdown-item to="/admin/user-management">
            User Management
          </b-dropdown-item>
          <b-dropdown-item to="/admin/announcements">
            Announcement Management
          </b-dropdown-item>
        </b-nav-item-dropdown>
      </b-navbar-nav>
      <b-navbar-nav class="ml-auto">
        <b-nav-item
          active-class="active"
          to="/faq"
        >
          FAQ
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/team"
        >
          Team
        </b-nav-item>
        <b-nav-item
          active-class="active"
          to="/support"
        >
          Support
        </b-nav-item>
        <b-nav-item-dropdown
          v-if="isAuthenticated && user"
          active-class="active"
          right
        >
          <template #button-content>
            {{ user.name || user.username }}
          </template>
          <b-dropdown-item :to="{ name: 'userSettings' }">
            Settings
          </b-dropdown-item>
          <b-dropdown-item @click="logout">
            Logout
          </b-dropdown-item>
        </b-nav-item-dropdown>
        <b-nav-item
          v-if="!isAuthenticated"
          active-class="active"
          to="/register"
        >
          Register
        </b-nav-item>
        <b-nav-item
          v-if="!isAuthenticated"
          :to="{ name: 'login', query: { redirect: $route.fullPath } }"
          active-class="active"
        >
          Login
        </b-nav-item>
      </b-navbar-nav>
    </b-collapse>
  </b-navbar>
</template>

<script lang="ts">
import Vue from 'vue';
import { mapGetters } from 'vuex';

export default Vue.extend({
  name: 'TheNavbar',

  computed: {
    ...mapGetters(['isAuthenticated', 'user']),
  },

  methods: {
    async logout() {
      await this.$store.dispatch('logout');
      this.$router.go(0);
    },
  },
});
</script>

<style scoped>
.nav-pills .nav-link.active {
  background-color: #646d82;
}
</style>
